﻿using System;
using System.IO;
using System.Threading;

using Syntriax.Engine.Core;
using Syntriax.Engine.Core.Debug;

Universe universe = new();

FileLogger fileLogger = new($"{Path.Combine(Directory.GetCurrentDirectory(), "logs", DateTime.UtcNow.ToString("yyyy-MM-dd_HH-mm-ss"))}.log");
universe.InstantiateUniverseObject().SetUniverseObject("Logger").BehaviourController
    .AddBehaviour<LoggerContainer>().Logger = new LoggerWrapper(fileLogger, new ConsoleLogger());

Pong.PongUniverse.ApplyPongUniverse(universe, isServerEnabled: true, isClientEnabled: false);

DateTime lastRun = DateTime.UtcNow;
TimeSpan interval = new(0, 0, 0, 0, 16);
TimeSpan timeSinceStart = new(0);

universe.Initialize();

while (true)
{
    if (lastRun + interval <= DateTime.UtcNow)
    {
        lastRun += interval;
        timeSinceStart += interval;
        universe.Update(new(timeSinceStart, interval));
    }
    Thread.Sleep(1);
}
